//
//  ExportSettingsViewController.h
//  DrivoMeter
//
//  Created by Triin Uudam on 4/10/12.
//  Copyright (c) 2012 Mobi Solutions OÜ. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MessageUI/MessageUI.h>
#import "SelectPeriodViewController.h"
#import "Export.h"

@class Period;
@class Database;
@class TwoLabelCell;
@class TextFieldCell;
@class MBProgressHUD;
@interface ExportSettingsViewController : UITableViewController <MFMailComposeViewControllerDelegate, selectPeriodDelegate, UITextFieldDelegate, UIActionSheetDelegate, ExportDelegate, UIAlertViewDelegate> {
  UIView *pickerView_;
  UIDatePicker *datePicker_;
  UIBarButtonItem *doneButton_;
  Database *database_;
  Period *exportPeriod_;
  TwoLabelCell *beginDateCell_;
  TwoLabelCell *endDateCell_;
  TextFieldCell *emailCell_;
  TwoLabelCell *selectedDateCell_;
  MBProgressHUD *hud_;
}

@property (nonatomic, strong) IBOutlet UIView *pickerView;
@property (nonatomic, strong) IBOutlet UIDatePicker *datePicker;
@property (nonatomic, strong) IBOutlet UIBarButtonItem *doneButton;
@property (nonatomic, strong) Database *database;
@property (nonatomic, strong) Period *exportPeriod;
@property (nonatomic, strong) TwoLabelCell *beginDateCell;
@property (nonatomic, strong) TwoLabelCell *endDateCell;
@property (nonatomic, strong) TextFieldCell *emailCell;
@property (nonatomic, strong) TwoLabelCell *selectedDateCell;
@property (nonatomic, strong) MBProgressHUD *hud;

- (IBAction)doneButtonPressed:(id)sender;
- (IBAction)datePickerValueChanged:(id)sender;

@end
