//
//  GPSTrack.h
//  DrivoMeter
//
//  Created by Mobi on 2/7/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreLocation/CoreLocation.h>

@protocol GPSTrackDelegate <NSObject>

- (void)updateDistance:(float)newDistance;
- (void)updatingDistanceFailed;

@end
@interface GPSTrack : NSObject <CLLocationManagerDelegate> {

  id<GPSTrackDelegate> delegate_;
  CLLocationManager *locationManager_;
  double currentDistance_;
  NSDate *locationManagerStart_;
}

@property (nonatomic, strong) CLLocationManager *locationManager;
@property (nonatomic) id<GPSTrackDelegate> delegate;
@property (nonatomic) double currentDistance;
@property (nonatomic, strong) NSDate *locationManagerStart_;

- (void)startUpdatingDistance;
- (void)stopUpdatingDistance;

@end
