//
//  OdometerPickerView.h
//  DrivoMeter
//
//  Created by Triin Uudam on 3/18/12.
//  Copyright (c) 2012 Mobi Solutions OÜ. All rights reserved.
//

#import <UIKit/UIKit.h>

@protocol OdometerPickerDelegate <NSObject>

- (void)updateOdometerValue:(NSString *)value;

@end
@interface OdometerPickerView : UIView <UIPickerViewDelegate, UIPickerViewDataSource> {
  id <OdometerPickerDelegate> delegate_;
  UIPickerView *picker_;
  UIView *parentView_;
}

@property (nonatomic, strong) IBOutlet UIPickerView *picker;
@property (nonatomic) id <OdometerPickerDelegate> delegate;
@property (nonatomic, strong) UIView *parentView;

- (void)showPickerOnView:(UIView *)view;
- (void)hidePickerFromView:(UIView *)view;

- (IBAction)doneButtonPressed:(id)sender;

@end
