//
//  TripViewController.h
//  DrivoMeter
//
//  Created by Triin Uudam on 1/3/12.
//

#import <UIKit/UIKit.h>
#import <CoreLocation/CoreLocation.h>
#import <MapKit/MapKit.h>
#import "CrumbPath.h"
#import "CrumbPathView.h"

@class Database;
@class Trip;
@class CustomSegmentedControl;
@interface TripViewController : UIViewController < MKMapViewDelegate, CLLocationManagerDelegate, UIApplicationDelegate, UIActionSheetDelegate> {

  UILabel *distanceTitleLabel_;
  UILabel *distanceStateLabel_;
  UIButton *actionButton_;
  Database *database_;
  CLLocationManager *locationManager_;
  BOOL isActive_;
  Trip *currentTrip_;
  double currentDistance_;
  MKMapView *mapView_;
  NSDate *locationManagerStart_;
  CrumbPath *crumbs_;
  CrumbPathView *crumbView_;
  UILocalNotification *futureAlert_;
  NSTimer *backgroundTimer_;
  double distanceInBackground_;
}

@property (nonatomic, strong) IBOutlet UILabel *distanceTitleLabel;
@property (nonatomic, strong) IBOutlet UILabel *distanceStateLabel;
@property (nonatomic, strong) IBOutlet UIButton *actionButton;
@property (nonatomic, strong) Database *database;
@property (nonatomic, strong) CLLocationManager *locationManager;
@property (nonatomic) BOOL isActive;
@property (nonatomic, strong) Trip *currentTrip;
@property (nonatomic) double currentDistance;
@property (nonatomic, strong) IBOutlet MKMapView *mapView;
@property (nonatomic, strong) NSDate *locationManagerStart;
@property (nonatomic, strong) UILocalNotification *futureAlert;
@property (nonatomic, strong) NSTimer *backgroundTimer;
@property (nonatomic) double distanceInBackground;

- (IBAction)actionButtonPressed:(id)sender;
- (IBAction)findMeButtonPressed;

@end
